.386 
.model flat,stdcall 
option casemap:none 
include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\gdi32.inc 
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\gdi32.lib 
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD 
drawcircle proto :WORD, :WORD, :WORD, :HDC


RGB macro red,green,blue 
    xor    eax,eax 
    mov  ah,blue 
    shl     eax,8 
    mov  ah,green 
    mov  al,red 
endm 

PLUS macro x0,x1
    xor eax,eax
    mov ax,x0
    add ax,x1
endm

MINUS macro x0,x1
    xor eax,eax
    mov ax,x0
    sub ax,x1
endm

swcrd macro 
    rol ebx,16
    rol ecx,16
endm   





.data 
ClassName db "SimpleWin32ASMBitmapClass",0 
AppName  db "Win32ASM Simple Bitmap Example",0 
radius WORD 100
xpos WORD 400
ypos WORD 400

.data? 
hInstance HINSTANCE ? 
CommandLine LPSTR ?  
hBitmap dd ?
hdc HDC ?
 

.code 
start: 
 invoke GetModuleHandle, NULL 
 mov    hInstance,eax 
 invoke GetCommandLine 
 mov    CommandLine,eax 
 invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT 
 invoke ExitProcess,eax 
 

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 
 LOCAL wc:WNDCLASSEX 
 LOCAL msg:MSG 
 LOCAL hwnd:HWND 
 mov   wc.cbSize,SIZEOF WNDCLASSEX 
 mov   wc.style, CS_HREDRAW or CS_VREDRAW 
 mov   wc.lpfnWndProc, OFFSET WndProc 
 mov   wc.cbClsExtra,NULL 
 mov   wc.cbWndExtra,NULL 
 push  hInstance 
 pop   wc.hInstance 
 mov   wc.hbrBackground,COLOR_WINDOW+1 
 mov   wc.lpszMenuName,NULL 
 mov   wc.lpszClassName,OFFSET ClassName 
 invoke LoadIcon,NULL,IDI_APPLICATION 
 mov   wc.hIcon,eax 
 mov   wc.hIconSm,eax 
 invoke LoadCursor,NULL,IDC_ARROW 
 mov   wc.hCursor,eax 
 invoke RegisterClassEx, addr wc 
 INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\ 
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\ 
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\ 
           hInst,NULL 
 mov   hwnd,eax 
 invoke ShowWindow, hwnd,SW_SHOWNORMAL 
 invoke UpdateWindow, hwnd 
 .while TRUE 
  invoke GetMessage, ADDR msg,NULL,0,0 
  .break .if (!eax) 
  invoke TranslateMessage, ADDR msg 
  invoke DispatchMessage, ADDR msg 
 .endw 
 mov     eax,msg.wParam 
 ret 
WinMain endp 



WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM  
   .if uMsg==WM_CREATE 
    pushad
    invoke GetDC, hWnd
    mov hdc, eax
    popad
   .elseif uMsg==WM_PAINT
    pushad
        invoke GetWindowDC,hWnd
        mov hdc,eax
        invoke drawcircle,radius,xpos,ypos,hdc
        ;invoke SetPixel,hdc,200,200,0
        invoke ReleaseDC,hWnd,hdc
    popad
    .elseif uMsg==WM_DESTROY
        invoke ReleaseDC,hWnd,hdc
        invoke PostQuitMessage,NULL
     .ELSE 
  invoke DefWindowProc,hWnd,uMsg,wParam,lParam 
  ret 
 .ENDIF 
 xor eax,eax 
 ret 
WndProc endp 

drawcircle proc r:WORD, xp:WORD,yp:WORD, dc:HDC
    LOCAL x:DWORD
    LOCAL yd:DWORD
    LOCAL xpow:DWORD
    LOCAL y:DWORD
mov bx,xp
rol ebx,16
mov bx,yp
mov cx,0
rol ecx,16
mov cx,r
xor edx,edx
mov dx, cx
shl edx,1
sub edx,1
mov edi,0
mov esi,dc

pusha
RGB 0,0,0
push eax
PLUS bx,cx
push eax
swcrd
PLUS bx,cx
push eax
push esi
call SetPixel           ;x,y
popa

pusha
RGB 0,0,0
push eax
swcrd
PLUS bx,cx
push eax
swcrd
PLUS bx,cx
push eax
push esi
call SetPixel           ;y,x
popa

pusha
RGB 0,0,0
push eax
MINUS bx,cx
push eax
swcrd
PLUS bx,cx
push eax
push esi
call SetPixel           ;x,-y
popa

pusha
RGB 0,0,0
push eax
swcrd
PLUS bx,cx
push eax
swcrd
MINUS bx,cx
push eax
push esi
call SetPixel           ;-y,x
popa

swcrd
push ebp
mov ebp,edx
loop1: 
      mov eax, ecx
      rol eax,16
      .if eax != ecx
        xor eax,eax
        add cx,1
        mov ax,cx
        shl eax,1
        sub eax,1
        add edi,eax
        .if edi >= edx
            swcrd
            sub cx,1
            sub ebp,2
            add edx,ebp
            swcrd
        .endif
        .else
            jmp endloop
       .endif

pusha
RGB 0,0,0
push eax
PLUS bx,cx
push eax                
swcrd
PLUS bx,cx
push eax
push esi
call SetPixel           ;x,y
popa

pusha
RGB 0,0,0
push eax
swcrd
PLUS bx,cx
push eax                
swcrd
PLUS bx,cx
push eax
push esi
call SetPixel          ;y,x
popa

pusha
RGB 0,0,0
push eax
MINUS bx,cx
push eax                
swcrd
PLUS bx,cx
push eax
push esi
call SetPixel      ;-x , y
popa

pusha
RGB 0,0,0
push eax
swcrd
MINUS bx,cx
push eax                
swcrd
PLUS bx,cx
push eax
push esi
call SetPixel   ;y,-x
popa

pusha
RGB 0,0,0
push eax
PLUS bx,cx
push eax                
swcrd
MINUS bx,cx
push eax
push esi
call SetPixel    ;x,-y
popa

pusha
RGB 0,0,0
push eax
swcrd
PLUS bx,cx
push eax                
swcrd
MINUS bx,cx
push eax
push esi
call SetPixel       ;y,-x
popa

pusha
RGB 0,0,0
push eax
MINUS bx,cx
push eax                
swcrd
MINUS bx,cx
push eax
push esi
call SetPixel       ;-x,-y
popa

pusha
RGB 0,0,0
push eax
swcrd
MINUS bx,cx
push eax                
swcrd
MINUS bx,cx
push eax
push esi
call SetPixel       ;-y,-x
popa


        
jmp loop1     
endloop:




pop ebp
ret
drawcircle endp
end start